#include <stdint.h>
#include <stdbool.h>
#ifndef __AHCC__
	#include <float.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <tos.h>
#include <aes.h>
#include <vdi.h>

#define g_x x
#define g_y y
#define g_w w
#define g_h h

#define BALKENBREITE 50

typedef struct
{
	int16_t g_x;
	int16_t g_y;
	int16_t g_w;
	int16_t g_h;
} PGRECT;

int16_t ghandle, vhandle;
int16_t gwchar, ghchar, gwbox, ghbox;
int16_t work_in[44], work_out[56];
int16_t whandle, wf;
char acc_name[] = "  HD Info ";
PGRECT work, deskxywh, redraw, clip;
int16_t vpxyarray[7], aa[7];

int16_t i;			/* allgemeine Zhlvariable */
int16_t raus = FALSE;

char lw[32];

typedef struct laufwerkinfo{
	uint32_t b_free;
	uint32_t b_total;
	uint32_t b_secsiz;
	uint32_t b_clsiz;
#ifdef __AHCC__
	uint32_t gesamt;
	uint32_t frei;
#else
	double gesamt;
	double frei;
#endif
	char text[255];
}laufwerkinfo;

laufwerkinfo laufwerk[32];

uint16_t strmlen, zeilen;

DISKINFO phdfree = {0,0,0,0};

extern int16_t _app;

int16_t max(int16_t a, int16_t b){
	return a>b ? a : b;
}

int16_t min(int16_t a, int16_t b){
	return a<b ? a : b;
}

/*int16_t rc_intersect (PGRECT *p1, PGRECT *p2){
	int16_t tx, ty, tw, th;
	tw = min(p2->g_x + p2->g_w, p1->g_x + p1->g_w);
	th = min(p2->g_y + p2->g_h, p1->g_y + p1->g_h);
	tx = max(p2->g_x, p1->g_x);
	ty = max(p2->g_y, p1->g_y);
	p2->g_x = tx;
	p2->g_y = ty;
	p2->g_w = tw - tx;
	p2->g_h = th - ty;
	return ((tw > tx) && (th > ty));
}*/

short rc_intersect (const PGRECT * r1, PGRECT * r2)
{
	short tx, ty, tw, th, ret;
	tx = max (r2->g_x, r1->g_x);
	tw = min (r2->g_x + r2->g_w, r1->g_x + r1->g_w) - tx;
	ret = (0 < tw);
	if (ret)
	{
		ty = max (r2->g_y, r1->g_y);
		th = min (r2->g_y + r2->g_h, r1->g_y + r1->g_h) - ty;
		ret = (0 < th);
		if (ret)
		{
			r2->g_x = tx;
			r2->g_y = ty;
			r2->g_w = tw;
			r2->g_h = th;
		}
	}
	return ret;
}

int16_t vwk_oeffnen(void){
	ghandle = graf_handle(&gwchar, &ghchar, &gwbox, &ghbox);
	vhandle = ghandle;
	for(i=0; i<10; i++){
		work_in[i]=1;
	}
	work_in[10]=2;
	v_opnvwk(work_in, &vhandle, work_out);
	if(vhandle != 0){
		return true;
	}
	else{
		return false;
	}
}

int16_t fenster_erstellen(void){
	int16_t whandle;
	char titel[] = "HD Info";
	wind_get(0,WF_WORKXYWH, &deskxywh.g_x, &deskxywh.g_y, &deskxywh.g_w, &deskxywh.g_h);
	whandle = wind_create(NAME+CLOSER+FULLER+MOVER+SIZER, deskxywh.g_x, deskxywh.g_y, deskxywh.g_w, deskxywh.g_h);
	wind_set(whandle, WF_NAME, &titel, 0, 0);
	return whandle;
}

void fenster_oeffnen(void){
	work.g_x = deskxywh.g_x;
	work.g_y = deskxywh.g_y;
	work.g_w = 100;
	work.g_h = 180;
	wind_calc(WC_BORDER, NAME+CLOSER+FULLER+MOVER+SIZER, work.g_x, work.g_y, strmlen*gwchar+BALKENBREITE+2, zeilen*ghbox, &redraw.g_x, &redraw.g_y, &redraw.g_w, &redraw.g_h);
	if(redraw.g_w < deskxywh.g_w){
		work.g_w = redraw.g_w;
	}
	if(redraw.g_h < deskxywh.g_h){
		work.g_h = redraw.g_h;
	}
	wind_open(whandle, work.g_x, work.g_y, work.g_w, work.g_h);
}

void hddinfo(void){
	uint16_t i;
	int32_t laufwerke;
	char alw = 'A';
	laufwerke = Drvmap();
	zeilen = 0;
	for(i=2;i<32;i++)
	{
		lw[i]=((laufwerke>>i)&1);
		if(lw[i] == 1){
			if(Dfree(&phdfree, i+1) == 0){
				laufwerk[i].b_free = phdfree.b_free;
				laufwerk[i].b_total = phdfree.b_total;
				laufwerk[i].b_secsiz = phdfree.b_secsiz;
				laufwerk[i].b_clsiz = phdfree.b_clsiz;
				#ifdef __AHCC__
					laufwerk[i].gesamt = ((((phdfree.b_secsiz>>8) * phdfree.b_clsiz) * phdfree.b_total)>>12);
					laufwerk[i].frei = ((((phdfree.b_secsiz>>8) * phdfree.b_clsiz) * phdfree.b_free)>>12);
					if((laufwerk[i].gesamt > 1024) && (laufwerk[i].frei > 1024)){
						sprintf(laufwerk[i].text, "%c: %ld GB (%ld%%) frei / %ld GB", alw+i, laufwerk[i].frei/1024, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt/1024);
					}
					else if(laufwerk[i].gesamt > 1024){
						sprintf(laufwerk[i].text, "%c: %ld MB (%ld%%) frei / %ld GB", alw+i, laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt/1024);
					}
					else{
						sprintf(laufwerk[i].text, "%c: %ld MB (%ld%%) frei / %ld MB", alw+i, laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), laufwerk[i].gesamt);
					}
				#else
					laufwerk[i].gesamt = (double)( (double)( (double)( (double)( phdfree.b_clsiz * phdfree.b_secsiz) * phdfree.b_total) / 1024) / 1024);
					laufwerk[i].frei = (double)( (double)( (double)( (double)( phdfree.b_clsiz * phdfree.b_secsiz) * phdfree.b_free) / 1024) / 1024);
					if((laufwerk[i].gesamt > 1024) && (laufwerk[i].frei > 1024)){
						sprintf(laufwerk[i].text, "%c: %.2lf GB (%.2lf%%) frei / %.2lf GB", alw+i, (double) laufwerk[i].frei/1024, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt/1024);
					}
					else if(laufwerk[i].gesamt > 1024){
						sprintf(laufwerk[i].text, "%c: %.2lf MB (%.2lf%%) frei / %.2lf GB", alw+i, (double) laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt/1024);
					}
					else{
						sprintf(laufwerk[i].text, "%c: %.2lf MB (%.2lf%%) frei / %.2lf MB", alw+i, (double) laufwerk[i].frei, (laufwerk[i].frei*100/laufwerk[i].gesamt), (double) laufwerk[i].gesamt);
					}
				#endif
				strmlen = max((int16_t) strlen(laufwerk[i].text), strmlen);
				zeilen++;
			}
		}
	}
}

void events(int16_t *msg_buf, int16_t menu_id){
	int16_t zeile = 0;
	switch (msg_buf[0])
	{
		case AC_OPEN:
			if (msg_buf[4] == menu_id){
				hddinfo();
				fenster_oeffnen();
			}
			break;
		case WM_REDRAW:
			graf_mouse(M_OFF, 0);
			wind_update(BEG_UPDATE);
			wind_get(msg_buf[3], WF_WORKXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			redraw.g_x = msg_buf[4];
			redraw.g_y = msg_buf[5];
			redraw.g_w = msg_buf[6];
			redraw.g_h = msg_buf[7];
			wind_get(msg_buf[3], WF_FIRSTXYWH, &clip.g_x, &clip.g_y, &clip.g_w, &clip.g_h);
			while(clip.g_w && clip.g_h){
				if(rc_intersect(&redraw, &clip)){
					aa[0] = clip.g_x;
					aa[1] = clip.g_y;
					aa[2] = clip.g_x+clip.g_w-1;
					aa[3] = clip.g_y+clip.g_h-1;
					vs_clip(vhandle, 1, aa);
					/*printf("REDRAW CLIP: %d %d %d %d\n",clip.g_x, clip.g_y, clip.g_w, clip.g_h);*/
					vst_color(vhandle, 1);		/* set graphic text color : schwarz */
					vswr_mode(vhandle, 1);		/* setting writing mode : replace */
					vsf_interior(vhandle, 1);	/* flltyp : deckend */
					vsf_color(vhandle, 0);		/* fllfarbe : weiss */
					v_bar(vhandle, aa);
					zeile = 0;
					for(i=2;i<32;i++){
						if(lw[i] == 1){
							if(zeile == 0){
								v_gtext(vhandle, work.g_x+1+BALKENBREITE, work.g_y+(ghbox/2)+2+(zeile*ghbox)+1, laufwerk[i].text);
								vsf_interior(vhandle, 1);	/* flltyp : voll */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+1;
								vpxyarray[2] = work.g_x+BALKENBREITE;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+1;
								v_bar(vhandle, vpxyarray);
								vsf_color(vhandle, 0);		/* fllfarbe : weiss */
								vpxyarray[0] = work.g_x+2;
								vpxyarray[1] = work.g_y+2;
								vpxyarray[2] = work.g_x+BALKENBREITE-1;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2);
								v_bar(vhandle, vpxyarray);
								vsf_interior(vhandle, 2);	/* flltyp: muster */
								vsf_style(vhandle, 4);		/* muster: 4 */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+1;
								vpxyarray[2] = work.g_x+(BALKENBREITE-(laufwerk[i].frei*100/laufwerk[i].gesamt)/2);
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+1;
								v_bar(vhandle, vpxyarray);
							}
							else{
								v_gtext(vhandle, work.g_x+1+BALKENBREITE, work.g_y+(ghbox/2)+1+(zeile*ghbox)+1, laufwerk[i].text);
								vsf_interior(vhandle, 1);	/* flltyp : voll */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+(zeile*ghbox);
								vpxyarray[2] = work.g_x+BALKENBREITE;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+(zeile*ghbox);
								v_bar(vhandle, vpxyarray);
								vsf_color(vhandle, 0);		/* fllfarbe : weiss */
								vpxyarray[0] = work.g_x+2;
								vpxyarray[1] = work.g_y+(zeile*ghbox)+1;
								vpxyarray[2] = work.g_x+BALKENBREITE-1;
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+(zeile*ghbox)-1;
								v_bar(vhandle, vpxyarray);
								vsf_interior(vhandle, 2);	/* flltyp: muster */
								vsf_style(vhandle, 4);		/* muster: 4 */
								vsf_color(vhandle, 1);		/* fllfarbe : schwarz */
								vpxyarray[0] = work.g_x+1;
								vpxyarray[1] = work.g_y+(zeile*ghbox);
								vpxyarray[2] = work.g_x+(BALKENBREITE-(laufwerk[i].frei*100/laufwerk[i].gesamt)/2);
								vpxyarray[3] = work.g_y+ghbox-(ghbox/2)+(zeile*ghbox);
								v_bar(vhandle, vpxyarray);
							}
							zeile = zeile + 1;
						}
					}
					vs_clip(vhandle, 0, aa);
				}
				wind_get(msg_buf[3], WF_NEXTXYWH, &clip.g_x, &clip.g_y, &clip.g_w, &clip.g_h);
			}
			wind_update(END_UPDATE);
			graf_mouse(M_ON, 0);
			break;
		case WM_TOPPED:
			wind_set(msg_buf[3], WF_TOP, msg_buf[4], msg_buf[5], msg_buf[6], msg_buf[7]);
			break;
		case AC_CLOSE:
		case WM_CLOSED:
		case AP_TERM:
			wind_close(msg_buf[3]);
			if(_app == 1){
				v_clsvwk(vhandle);
				/*appl_exit();*/
				raus = TRUE;
			}
			break;
		case WM_FULLED:
			if(wf == 0){
				wf = 1;
				wind_get(msg_buf[3], WF_FULLXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			}
			else{
				wf = 0;
				wind_get(msg_buf[3], WF_PREVXYWH, &work.g_x, &work.g_y, &work.g_w, &work.g_h);
			}
			wind_set(msg_buf[3], WF_CURRXYWH, work.g_x, work.g_y, work.g_w, work.g_h);
			break;
		case WM_SIZED:
		case WM_MOVED:
			wind_set(msg_buf[3], WF_CURRXYWH, msg_buf[4], msg_buf[5], msg_buf[6], msg_buf[7]);
			break;
	}
}

int16_t main(void){
	int16_t ap_id, menu_id = 0;
	int16_t msg_buf[8], event, dummy, pmx, pmy, pmb;
	
	ap_id = appl_init();
	
	if (ap_id >= 0){
		if(vwk_oeffnen()){
			if(_app == 0){
				menu_id = menu_register(ap_id, acc_name);
			}
			if ((menu_id >= 0) | (_app == 1)){
				whandle = fenster_erstellen();
				if(_app == 1){
					hddinfo();
					fenster_oeffnen();
				}
				while(!raus){
					/*evnt_mesag(msg_buf);*/
					event = evnt_multi(MU_MESAG | MU_BUTTON | MU_TIMER, 
						1, 0x001, 0x001,
						0, 0, 0, 0, 0,
						0, 0, 0, 0, 0,
						msg_buf, 200, 0,
						&pmx, &pmy, &pmb, &dummy, &dummy, &dummy);
					if(event & MU_BUTTON){
						evnt_button(1, 0x001, 0x000, &pmx, &pmy, &pmb, &dummy);
						if(wind_find(pmx, pmy) == whandle){
							/*printf("MU_BUTTON: %d %d %d\n",pmx, pmy, pmb);*/
						}
					}
					if(event & MU_MESAG){
						events(msg_buf, menu_id);
					}
				}
				return(EXIT_SUCCESS);
			}
		}
	}
	if(_app == 0){
		for(;;) evnt_mesag (msg_buf);
	}
	else{
		/*appl_exit();*/
		return(EXIT_FAILURE);
	}
}
